/***************************************************************************
          ibexception.h  -  exception created by ibasepp; 
                             -------------------
    begin                : Fri May 5 2000
    copyright            : (C) 2000 by Vadim Morgunov
    email                : vvm@kis.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef IBEXCEPTION_H
#define IBEXCEPTION_H

#include <exception>
#include <string>
extern "C" {
#include <stdio.h>
#include <stdlib.h>
#include <ibase.h>
}

#include "ibasepp_common.h"

using namespace std;

/***************************************************************************
    ibasepp
 ***************************************************************************/
class IBException : public exception  {
public: // 
  IBException(const char* source, const int line, const char* message);
  IBException(const char* source, const int line, long* pvector);
public: // methods
  virtual const char* what() { return _what.c_str(); };
private: // fields
  string _what;
private:
  const char* formatStr(const char* fromat, ...);
};

#endif
